using e_suite.API.Common.models;
using e_suite.Utilities.Pagination;
using Microsoft.AspNetCore.Mvc;
using Moq;
using NUnit.Framework;

namespace eSuite.API.UnitTests.Controllers.RoleControllerUnitTests;

[TestFixture]
public class GetAccessListUnitTests : RoleControllerTestBase
{
    [SetUp]
    public override async Task Setup()
    {
        await base.Setup();
    }

    [Test]
    public async Task GetAccessList_WhenCalled_ReturnsPagedData()
    {
        //Arrange
        var domains = new List<GetSecurityAccess>();

        var paginatedData = new PaginatedData<GetSecurityAccess>
        {
            Count = domains.Count,
            Data = domains,
            Page = 1,
            PageSize = 10
        };

        var cancellationToken = CancellationToken.None;

        var paging = new Paging();

        _roleManagerMock.Setup(x => x.GetAccessList(paging, cancellationToken)).ReturnsAsync(paginatedData);

        //Act
        var actualResult = await _roleController.GetAccessList(paging, cancellationToken);

        //Assert
        Assert.That(actualResult.GetType(), Is.EqualTo(typeof(OkObjectResult)));
        var objectResult = actualResult as OkObjectResult;

        Assert.That(objectResult?.StatusCode, Is.EqualTo(200));
        Assert.That(objectResult?.Value, Is.Not.Null);
        Assert.That(objectResult!.Value!.GetType, Is.EqualTo(typeof(PaginatedData<GetSecurityAccess>)));
    }
}